﻿using UnityEngine;
using System.Collections;
using System;

public class objsound : MonoBehaviour {
	rtcmixmain RTcmix;
	int objno = 0; // change this for multiple RTcmix instantiations
	public TextAsset score1;
	string objscore;

	Bounds inbox;

	// Use this for initialization
	void Start () {
		objscore = score1.text;
		
		RTcmix = GameObject.Find ("RTcmixmain").GetComponent<rtcmixmain> ();
		RTcmix.initRTcmix (objno);

		RTcmix.SendScore ("MAXBANG(0.1)", objno);

		inbox = new Bounds (new Vector3(0, 2, 0), new Vector3(4, 4, 4));
	}
	
	// Update is called once per frame
	void Update () {
		// distance
		GameObject observer = GameObject.Find ("observer");
		Transform observertransform = observer.transform;
		Vector3 actualcenter = new Vector3 (transform.position.x,
			transform.position.y + 2.0f,
			transform.position.z);
		float distance = Vector3.Distance (observertransform.position, actualcenter);
		float freqmult = (1.0f - distance / 20.0f) * 5000.0f;
		if (freqmult < 500.0f)
			freqmult = 500.0f;

		RTcmix.setpfieldRTcmix (1, freqmult, objno);

		float rvbamp = 0.0f;
		if (inbox.Contains (new Vector3 (observertransform.position.x,
			    observertransform.position.y,
			    observertransform.position.z))) {
			rvbamp = (1.0f - distance / 2.0f);
			if (rvbamp > 1.0f)
				rvbamp = 1.0f;
            if (rvbamp < 0.0f)
                rvbamp = 0.0f;
		}

		RTcmix.setpfieldRTcmix (2, rvbamp, objno);
	}

	// this function is called by unity for every buffer of sound samples computed
	void OnAudioFilterRead(float[] data, int channels) {
		RTcmix.runRTcmix (data, objno, 0);

		if (RTcmix.checkbangRTcmix (objno) == 1) {
			RTcmix.SendScore (objscore, objno);
		}
	}

	void OnApplicationQuit() {
		RTcmix.destroy (objno);
	}

}
